// 7941W Demo - Dual Frequency RFID Module
// HackerBoxes.com

#include <SoftwareSerial.h>

byte buf[500];
int buflen;

SoftwareSerial rfidSerial = SoftwareSerial(3,2);; // RX, TX

void setup() {
  rfidSerial.begin(115200);// this connects to the other USART device
  Serial.begin(115200);  // this one connects to a computer via USB
}

void CommandList() {
  Serial.println("0) This Command List");
  Serial.println("1) Command 0x10: Read UID from 13.56MHz RFID");
  Serial.println("2) Command 0x11: Write UID to 13.56MHz RFID"); 
  Serial.println("3) Command 0x12: Read Specified Sector from 13.56MHz RFID");
  Serial.println("4) Command 0x13: Write Specified Sector to 13.56MHz RFID");
  Serial.println("5) Command 0x14: Modify Group Password on 13.56MHz RFID");
  Serial.println("6) Command 0x15: Read ID number from 125KHz RFID");
  Serial.println("7) Command 0x16: Write ID number to 125KHz RFID");
  Serial.println("8) Command 0x17: Read Sector Data from 13.56MHz RFID");
}

void Cmd0x10() {
  Serial.println("Command 0x10: Read UID from 13.56MHz RFID");
  Serial.println("Transmit: AB BA 00 10 00 10");
  rfidSerial.write((byte)0xAB);
  rfidSerial.write((byte)0xBA);
  rfidSerial.write((byte)0x00);  // address
  rfidSerial.write((byte)0x10);  // command
  rfidSerial.write((byte)0x00);  // data length
  rfidSerial.write((byte)0x10);  // XOR checksum
  getresponse();
}

void Cmd0x11() {
  Serial.println("Command 0x11: Write UID to 13.56MHz RFID");
  Serial.println("Transmit: AB BA 00 11 04 6D E9 5C 17 DA");
  rfidSerial.write((byte)0xAB);
  rfidSerial.write((byte)0xBA);
  rfidSerial.write((byte)0x00);  // address
  rfidSerial.write((byte)0x11);  // command
  rfidSerial.write((byte)0x04);  // data length
  rfidSerial.write((byte)0x6D);  // 
  rfidSerial.write((byte)0xE9);  // 
  rfidSerial.write((byte)0x5C);  // 
  rfidSerial.write((byte)0x17);  // 
  rfidSerial.write((byte)0xDa);  // XOR checksum
  getresponse();
}

void Cmd0x12() {
  Serial.println("Command 0x12: Read Specified Sector from 13.56MHz RFID");
  Serial.println("Transmit: AB BA 12 09 00 01 0A FF FF FF FF FF FF 10");
  rfidSerial.write((byte)0xAB);
  rfidSerial.write((byte)0xBA);
  rfidSerial.write((byte)0x00);  // address
  rfidSerial.write((byte)0x12);  // command
  rfidSerial.write((byte)0x09);  // data length
  rfidSerial.write((byte)0x00);  // Specific Sector
  rfidSerial.write((byte)0x01);  // Block of the Sector
  rfidSerial.write((byte)0x0A);  // A or B Group
  rfidSerial.write((byte)0xFF);  // next 6 bytes are the password
  rfidSerial.write((byte)0xFF);  // 
  rfidSerial.write((byte)0xFF);  // 
  rfidSerial.write((byte)0xFF);  // 
  rfidSerial.write((byte)0xFF);  // 
  rfidSerial.write((byte)0xFF);  // 
  rfidSerial.write((byte)0x10);  // XOR checksum
  getresponse();
}

void Cmd0x13() {
  Serial.println("Command 0x13: Write Specified Sector to 13.56MHz RFID");
  Serial.println("Transmit: AB BA 00 13 19 00 01 0A FF FF FF FF FF FF 00 01 02 03 04 05 06 07 08 09 01 02 03 04 05 06 07");
  rfidSerial.write((byte)0xAB);
  rfidSerial.write((byte)0xBA);
  rfidSerial.write((byte)0x00);  // address
  rfidSerial.write((byte)0x13);  // command
  rfidSerial.write((byte)0x19);  // data length
  rfidSerial.write((byte)0x00);  // Specific Sector
  rfidSerial.write((byte)0x01);  // Block of the Sector
  rfidSerial.write((byte)0x0A);  // A or B Group
  rfidSerial.write((byte)0xFF);  // next 6 bytes are the password
  rfidSerial.write((byte)0xFF);  // 
  rfidSerial.write((byte)0xFF);  // 
  rfidSerial.write((byte)0xFF);  // 
  rfidSerial.write((byte)0xFF);  // 
  rfidSerial.write((byte)0xFF);  //
  rfidSerial.write((byte)0x00);  //
  rfidSerial.write((byte)0x01);  //
  rfidSerial.write((byte)0x02);  //
  rfidSerial.write((byte)0x03);  //
  rfidSerial.write((byte)0x04);  //
  rfidSerial.write((byte)0x05);  //
  rfidSerial.write((byte)0x06);  //
  rfidSerial.write((byte)0x07);  //
  rfidSerial.write((byte)0x08);  //
  rfidSerial.write((byte)0x09);  //
  rfidSerial.write((byte)0x01);  //
  rfidSerial.write((byte)0x02);  //
  rfidSerial.write((byte)0x03);  //
  rfidSerial.write((byte)0x04);  //
  rfidSerial.write((byte)0x05);  //
  rfidSerial.write((byte)0x06);  //
  rfidSerial.write((byte)0x07);  //
  rfidSerial.write((byte)0x10);  // XOR checksum
  getresponse();
}

void Cmd0x14() {
  Serial.println("Command 0x14: Modify Group Password on 13.56MHz RFID");
  Serial.println("Transmit: AB BA 00 14 0E 00 0A FF FF FF FF FF FF 01 02 03 04 05 06 17");
  rfidSerial.write((byte)0xAB);
  rfidSerial.write((byte)0xBA);
  rfidSerial.write((byte)0x00);  // address
  rfidSerial.write((byte)0x14);  // command
  rfidSerial.write((byte)0x0E);  // data length
  rfidSerial.write((byte)0x00);  // Specific Sector
  rfidSerial.write((byte)0x0A);  // A or B Group
  rfidSerial.write((byte)0xFF);  // next 6 bytes are the OLD password
  rfidSerial.write((byte)0xFF);  // 
  rfidSerial.write((byte)0xFF);  // 
  rfidSerial.write((byte)0xFF);  // 
  rfidSerial.write((byte)0xFF);  // 
  rfidSerial.write((byte)0xFF);  //
  rfidSerial.write((byte)0x01);  // next 6 bytes are the NEW password 
  rfidSerial.write((byte)0x02);  //
  rfidSerial.write((byte)0x03);  //
  rfidSerial.write((byte)0x04);  //
  rfidSerial.write((byte)0x05);  //
  rfidSerial.write((byte)0x06);  //
  rfidSerial.write((byte)0x99);  // This should be 0x17, but we need it to fail or demo PW stops working
  Serial.println("Intentionally Failes Checksum to keep PW from changing");
  getresponse();
}

void Cmd0x15() {
  Serial.println("Command 0x15: Read ID number from 125KHz RFID");
  Serial.println("Transmit: AB BA 00 15 00 15");
  rfidSerial.write((byte)0xAB);
  rfidSerial.write((byte)0xBA);
  rfidSerial.write((byte)0x00);  // address
  rfidSerial.write((byte)0x15);  // command
  rfidSerial.write((byte)0x00);  // data length
  rfidSerial.write((byte)0x15);  // XOR checksum
  getresponse();
}

void Cmd0x16() {
  Serial.println("Command 0x16: Write ID number to 125KHz RFID");
  Serial.println("Transmit: AB BA 00 16 05 00 00 03 92 5D DF");
  rfidSerial.write((byte)0xAB);
  rfidSerial.write((byte)0xBA);
  rfidSerial.write((byte)0x00);
  rfidSerial.write((byte)0x16);  // command
  rfidSerial.write((byte)0x05);  // data length
  rfidSerial.write((byte)0x00);  // next 5 bytes: ID data
  rfidSerial.write((byte)0x00);
  rfidSerial.write((byte)0x03);  
  rfidSerial.write((byte)0x92);
  rfidSerial.write((byte)0x5D);
  rfidSerial.write((byte)0xDF);  // XOR checksum
  getresponse();
}

void Cmd0x17() {
  Serial.println("Command 0x17: Read Sector Data from 13.56MHz RFID");
  Serial.println("Transmit: AB BA 00 17 07 0A FF FF FF FF FF FF 1A");
  rfidSerial.write((byte)0xAB);
  rfidSerial.write((byte)0xBA);
  rfidSerial.write((byte)0x00);
  rfidSerial.write((byte)0x17);  // command
  rfidSerial.write((byte)0x07);  // data length
  rfidSerial.write((byte)0x0A);  
  rfidSerial.write((byte)0xFF);
  rfidSerial.write((byte)0xFF);  
  rfidSerial.write((byte)0xFF);
  rfidSerial.write((byte)0xFF);
  rfidSerial.write((byte)0xFF);
  rfidSerial.write((byte)0xFF);
  rfidSerial.write((byte)0x1A);  // XOR checksum
  getresponse();
}

void getresponse() {
  int i = 0;
  
  delay(100);
  //collect any response into buf[]
  while((rfidSerial.available() > 0) && (i < 500)) {
    buf[i++] = rfidSerial.read();
    delay(50);
  }
  buflen = i;

  Serial.print("Response: ");
  //echo response to serial output
  for (i=0; i<buflen; i++) {
    Serial.print(buf[i],HEX); 
    Serial.print(" ");
  }
  Serial.println("");

  //display status of response
  if (buflen > 0) {
    if (buf[3] == 0x80) {
      Serial.print("Operation Failed  ");
    } else if (buf[3] == 0x81) {
      Serial.print("Operation Succeeded  ");
    } else {
      Serial.print("Undefined Response  ");
    }

    //we could verify the response checksum here
    Serial.println("");
  }
}

void loop() {
  Serial.println("");
  Serial.println("Enter 0 for Command List");

  while(!Serial.available());
  char newchar = Serial.read();
  switch (newchar){
    case '0':
      CommandList();
      break;
    case '1':
      Cmd0x10();
      break;
    case '2':
      Cmd0x11();
      break;
    case '3':
      Cmd0x12();
      break;
    case '4':
      Cmd0x13();
      break;
    case '5':
      Cmd0x14();
      break;
    case '6':
      Cmd0x15();
      break;
    case '7':
      Cmd0x16();
      break;
    case '8':
      Cmd0x17();
      break;
  }
}
